namespace std {
         typedef int ptrdiff_t;
         template<typename _Tp, _Tp __v>     struct integral_constant     {
            static constexpr _Tp value = __v;
            typedef integral_constant type;
          };
         typedef integral_constant<bool, true> true_type;
         typedef integral_constant<bool, false> false_type;
         template<bool __v>     using __bool_constant = integral_constant<bool, __v>;
         template<bool, typename, typename>     struct conditional;
         template<typename...>     struct __or_;
         template<typename _B1, typename _B2>     struct __or_<_B1, _B2>     : public conditional<_B1::value, _B1, _B2>::type     {};
         template<typename _B1, typename _B2, typename _B3, typename... _Bn>     struct __or_<_B1, _B2, _B3, _Bn...>     : public conditional<_B1::value, _B1, __or_<_B2, _B3, _Bn...>>::type     {};
         template<typename...>     struct __and_;
         template<typename _B1, typename _B2>     struct __and_<_B1, _B2>     : public conditional<_B1::value, _B2, _B1>::type     {};
         template<typename _Pp>     struct __not_     : public __bool_constant<!bool()>     {};
         template<typename _Tp>     struct __success_type     {
      typedef _Tp type;
      };
         template<typename>     struct remove_cv;
         template<typename>     struct __is_void_helper     : public false_type {};
         template<typename _Tp>     struct is_void     : public __is_void_helper<typename remove_cv<_Tp>::type>::type     {};
         template<typename>     struct is_array     : public false_type {};
         template<typename>     struct __is_pointer_helper     : public false_type {};
         template<typename _Tp>     struct is_pointer     : public __is_pointer_helper<typename remove_cv<_Tp>::type>::type     {};
         template<typename>     struct is_function;
         template<typename>     struct __is_member_function_pointer_helper     : public false_type {};
         template<typename _Tp, typename _Cp>     struct __is_member_function_pointer_helper<_Tp _Cp::*>     : public is_function<_Tp>::type {};
         template<typename _Tp>     struct is_member_function_pointer     : public __is_member_function_pointer_helper<     typename remove_cv<_Tp>::type>::type     {};
         template<typename>     struct is_function     : public false_type {};
         template<typename _Res, typename... _ArgTypes , bool _NE>     struct is_function<_Res(_ArgTypes...) const noexcept (_NE)>     : public true_type {};
         template<typename _Tp>     _Tp     __declval(long);
         template<typename _Tp>     auto declval() noexcept -> decltype(__declval<_Tp>(0));
         template<typename _Tp, typename... _Args>     struct is_constructible       : public __bool_constant<__is_constructible(_Tp, _Args...)>     {};
         template<typename _Tp>     struct is_default_constructible     : public is_constructible<_Tp>::type     {};
         template<typename _From, typename _To,            bool = __or_<is_void<_From>, is_function<_To>,                         is_array<_To>>::value>     struct __is_convertible_helper     {
            template<typename _To1>  static void __test_aux() noexcept;
            template<typename _From1, typename _To1,         typename = decltype(0)>  static true_type  __test(int);
          public:       typedef decltype(__test<_From, _To>(0)) type;
          };
         template<typename _From, typename _To>     struct is_convertible     : public __is_convertible_helper<_From, _To>::type     {};
         template<typename _Tp>     struct remove_const     {
      typedef _Tp type;
      };
         template<typename _Tp>     struct remove_volatile     {
      typedef _Tp type;
      };
         template<typename _Tp>     struct remove_cv     {
            typedef typename       remove_const<typename remove_volatile<_Tp>::type>::type type;
          };
         template<typename _Tp>     struct remove_reference     {
      typedef _Tp type;
      };
         template<typename _Tp>     struct remove_reference<_Tp&>     {
      typedef _Tp type;
      };
         template<typename _Tp>     struct remove_reference<_Tp&&>     {
      typedef _Tp type;
      };
         template<typename _Tp>     using remove_reference_t = typename remove_reference<_Tp>::type;
         template<typename _Up,     bool _IsArray = is_array<_Up>::value,     bool _IsFunction = is_function<_Up>::value>     struct __decay_selector;
         template<typename _Up>     struct __decay_selector<_Up, false, false>     {
      typedef typename remove_cv<_Up>::type __type;
      };
         template<typename _Tp>     class decay     {
            typedef typename remove_reference<_Tp>::type __remove_type;
          public:       typedef typename __decay_selector<__remove_type>::__type type;
          };
         template<bool, typename _Tp = void>     struct enable_if     {
      typedef _Tp type;
      };
         template<bool _Cond, typename _Iftrue, typename _Iffalse>     struct conditional     {
      typedef _Iftrue type;
      };
         template<typename _Iftrue, typename _Iffalse>     struct conditional<false, _Iftrue, _Iffalse>     {
      typedef _Iffalse type;
      };
         template<typename... _Tp>     struct common_type;
         struct __do_common_type_impl   {
          template<typename _Tp, typename _Up>       static __success_type<typename decay<decltype        (true ? std::declval<_Tp>()         : std::declval<_Up>())>::type> _S_test(int);
        };
         template<typename _Tp, typename _Up>     struct __common_type_impl     : private __do_common_type_impl     {
            typedef decltype(_S_test<_Tp, _Up>(0)) type;
          };
         template<typename _Tp, typename _Up>     struct common_type<_Tp, _Up>     : public __common_type_impl<_Tp, _Up>::type     {};
         template<typename _Tp>     using decay_t = typename decay<_Tp>::type;
         template<bool _Cond, typename _Tp = void>     using enable_if_t = typename enable_if<_Cond, _Tp>::type;
         template<typename... _Tp>     using common_type_t = typename common_type<_Tp...>::type;
         template<typename...> using __void_t = void;
         template<typename _Default, typename _AlwaysVoid,     template<typename...> class _Op, typename... _Args>     struct __detector     {
            using type = _Default;
          };
         template<typename _Default, template<typename...> class _Op,     typename... _Args>     using __detected_or = __detector<_Default, void, _Op, _Args...>;
         template<typename _Default, template<typename...> class _Op,     typename... _Args>     using __detected_or_t       = typename __detected_or<_Default, _Op, _Args...>::type;
       template <typename _Tp>   inline constexpr bool is_member_function_pointer_v =     is_member_function_pointer<_Tp>::value;
       }
        extern "C" 
       typedef unsigned int size_t;
       __extension__ typedef struct 
       __fsid_t;
       __extension__ typedef long int __time_t;
       __extension__ typedef long int __syscall_slong_t;
       struct timespec   {
          __time_t tv_sec;
          __syscall_slong_t tv_nsec;
        };
       
        namespace std {
         
         template<typename _Tp>     constexpr _Tp&&     forward(void) noexcept     ;
            template<typename _Tp>     constexpr typename std::remove_reference<_Tp>::type&&     move(_Tp&& __t) noexcept     {};
         template<class _E>     class initializer_list     ;
         template<typename _Tp, _Tp... _Idx>     struct integer_sequence     ;
       }
        
       template<typename Lhs, typename Rhs> struct HashCompatible : std::false_type {};
       template<typename RealType, typename ValueType = int> class StronglyTypedNumber {
      public:     StronglyTypedNumber() = default;
               explicit constexpr StronglyTypedNumber(ValueType value)         : m_value()     {}
      protected:     ValueType m_value;
      };
       struct ByteCount : public StronglyTypedNumber<ByteCount, int> {
          ByteCount() = default;
               constexpr ByteCount(int value) : StronglyTypedNumber() {}
      };
        
        namespace std __attribute__ (()) {
         struct input_iterator_tag {};
         struct forward_iterator_tag : public input_iterator_tag {};
         struct bidirectional_iterator_tag : public forward_iterator_tag {};
         struct random_access_iterator_tag : public bidirectional_iterator_tag {};
         template<typename _Category, typename _Tp, typename _Distance = ptrdiff_t,            typename _Pointer = _Tp*, typename _Reference = _Tp&>     struct iterator     {
            typedef _Category iterator_category;
            typedef _Tp value_type;
            typedef _Distance difference_type;
          };
         template<typename _Iterator, typename = __void_t<>>     struct __iterator_traits {
            typedef typename _Iterator::iterator_category iterator_category;
            typedef typename _Iterator::value_type value_type;
            typedef typename _Iterator::difference_type difference_type;
          };
         template<typename _Iterator>     struct iterator_traits     : public __iterator_traits<_Iterator> {};
         template<typename _Tp>     struct iterator_traits<_Tp*>     {
            typedef random_access_iterator_tag iterator_category;
            typedef _Tp value_type;
            typedef ptrdiff_t difference_type;
            typedef _Tp& reference;
          };
         template<typename _InIter>     using _RequireInputIter = typename       enable_if<is_convertible<typename   iterator_traits<_InIter>::iterator_category,           input_iterator_tag>::value>::type;
         template<typename _Tp, typename _Up>     struct __replace_first_arg     {};
         template<typename _Ptr>     struct pointer_traits     {
            template<typename _Up>         using rebind = _Up*;
          };
       }
        
         using std::iterator_traits;
         template<typename _Iterator, typename _Container>     class __normal_iterator     {
            typedef iterator_traits<_Iterator> __traits_type;
          public:       typedef _Iterator iterator_type;
            typedef typename __traits_type::iterator_category iterator_category;
            typedef typename __traits_type::value_type value_type;
            typedef typename __traits_type::difference_type difference_type;
            typedef typename __traits_type::reference reference;
            reference       operator*() const noexcept       ;
            void        operator++() noexcept       ;
                                                    };
         template<typename _IteratorL, typename _IteratorR, typename _Container>      bool     operator!=(const __normal_iterator<_IteratorL, _Container>& __lhs,         const __normal_iterator<_IteratorR, _Container>& __rhs)     noexcept     ;
       
        namespace std __attribute__ (()) {
         template<typename>     class allocator;
       }
        typedef struct 
        pthread_barrierattr_t;
        namespace std __attribute__ (()) {
         template<typename _Container>      constexpr auto     begin(const _Container& __cont) -> decltype(__cont.begin())     ;
         template<typename _Container>      constexpr auto     end(_Container& __cont) -> decltype(__cont.end())     ;
         struct __allocator_traits_base   {
          template<typename _Tp, typename _Up, typename = void>       struct __rebind : __replace_first_arg<_Tp, _Up> {
     using type = typename _Tp::template rebind<_Up>::other;
     };
        protected:     template<typename _Tp>       using __pointer = typename _Tp::pointer;
          template<typename _Tp>       using __c_pointer = typename _Tp::const_pointer;
        };
         template<typename _Alloc, typename _Up>     using __alloc_rebind       = typename __allocator_traits_base::template __rebind<_Alloc, _Up>::type;
         template<typename _Alloc>     struct allocator_traits : __allocator_traits_base     {
            typedef typename _Alloc::value_type value_type;
            using pointer = __detected_or_t<value_type*, __pointer, _Alloc>;
          private:       template<template<typename> class _Func, typename _Tp, typename = void>  struct _Ptr  {
        using type = typename pointer_traits<pointer>::template rebind<_Tp>;
      };
          public:       using const_pointer = typename _Ptr<__c_pointer, const value_type>::type;
            template<typename _Tp>  using rebind_alloc = __alloc_rebind<_Alloc, _Tp>;
          };
       }
        
       template<typename _Alloc, typename = typename _Alloc::value_type>   struct __alloc_traits   : std::allocator_traits<_Alloc>   {
          typedef std::allocator_traits<_Alloc> _Base_type;
          template<typename _Tp>       struct rebind       {
     typedef typename _Base_type::template rebind_alloc<_Tp> other;
     };
        };
       
        
       template<typename T, size_t N> struct Array ;
       template<typename T, size_t N> constexpr Array<T, N> make_array0 ;
       
      struct Trans_NS_Meta_AnyType{};
      template<typename T> struct Trans_NS_Meta_Type : Trans_NS_Meta_AnyType {};
      
       enum class MemoryDomain {
          Undefined,                    BufferMeta,     Options,                                                                                                     };
         template<typename T, MemoryDomain domain> struct Allocator {
          using value_type = T;
                    template<typename U>     struct rebind {
     using other = Allocator;
     };
                };
       constexpr MemoryDomain memory_domain(void) {
      return MemoryDomain::Undefined;
      }
       template<MemoryDomain d> struct UseMemoryDomain {};
       
        namespace std __attribute__ (()) {
         struct allocator_arg_t ;
         template<typename _Tp, typename _Alloc>     struct _Vector_base     {
            typedef typename __alloc_traits<_Alloc>::template  rebind<_Tp>::other _Tp_alloc_type;
            typedef typename __alloc_traits<_Tp_alloc_type>::pointer         pointer;
          };
         template<typename _Tp, typename _Alloc = std::allocator<_Tp> >     class vector : protected _Vector_base<_Tp, _Alloc>     {
            typedef _Vector_base<_Tp, _Alloc> _Base;
            typedef typename _Base::_Tp_alloc_type _Tp_alloc_type;
            typedef __alloc_traits<_Tp_alloc_type> _Alloc_traits;
          public:       typedef _Tp value_type;
            typedef typename _Base::pointer pointer;
            typedef typename _Alloc_traits::const_pointer const_pointer;
            typedef __normal_iterator<pointer, vector> iterator;
            typedef __normal_iterator<const_pointer, vector>       const_iterator;
            typedef _Alloc allocator_type;
            template<typename _InputIterator,         typename = std::_RequireInputIter<_InputIterator>>  vector(_InputIterator __first, _InputIterator __last)   ;
            const_iterator       begin() const noexcept       ;
            iterator       end() noexcept       ;
          };
                   }
        
       template<typename Func> struct ViewFactory {
      Func func;
      };
       template<typename Func> ViewFactory<std::decay_t<Func>> make_view_factory(Func&& func) {}
       template<typename Range, typename Func> decltype(auto) operator| (Range&& range, ViewFactory<Func> factory) {
          return factory.func(std::forward<Range>());
      }
       template<typename Range> struct decay_range_impl {
      using type = std::decay_t<Range>;
      };
       template<typename Range> struct decay_range_impl<Range&> {
      using type = Range&;
      };
       template<typename Range> using decay_range = typename decay_range_impl<Range>::type;
       template<typename Range> using IteratorOf = decltype(std::begin(std::declval<Range>()));
       template<typename Range, typename Filter> struct FilterView {
          using RangeIt = IteratorOf<Range>;
          struct Iterator : std::iterator<std::forward_iterator_tag,                                     typename std::iterator_traits<RangeIt>::value_type>     {
             
             decltype(auto) operator*() {
    return *m_it;
            }
             RangeIt m_it;
         };
          Iterator begin() const ;
          Range m_range;
          mutable Filter m_filter;
      };
       template<typename Filter> inline auto filter(Filter f) {
          return make_view_factory([f = std::move(f)](auto&& range) {
             using Range = decltype(range);
             return FilterView<decay_range<Range>, Filter>{
   std::forward<Range>(), std::move(f)};
         }
     );
      }
       template<typename Range, typename Transform> struct TransformView {
          using RangeIt = IteratorOf<Range>;
          using ResType = decltype(std::declval<Transform>()(*std::declval<RangeIt>()));
          struct Iterator     {
             using iterator_category = typename std::iterator_traits<RangeIt>::iterator_category;
             using value_type = std::remove_reference_t<ResType>;
             using difference_type = typename std::iterator_traits<RangeIt>::difference_type;
             decltype(auto) operator*() {
    return (*m_transform)(*m_it);
    }
         private:         RangeIt m_it;
             Transform* m_transform;
         };
          Iterator begin() const ;
          Iterator end() const ;
          Range m_range;
          mutable Transform m_transform;
      };
       template<typename Transform> inline auto transform(Transform t) {
          return make_view_factory([t = std::move(t)](auto&& range) {
             using Range = decltype(range);
             return TransformView<decay_range<Range>, Transform>{
   std::forward<Range>(), std::move(t)};
         }
     );
      }
       template<typename T, typename U, typename = void> struct is_pointer_like : std::false_type {};
       template<typename M, typename T> inline auto transform(M T::*member) {
          return transform([member](auto&& arg) -> decltype(auto) {
             using Arg = decltype(arg);
             using Member = decltype(member);
             auto get_object = [&] () mutable -> decltype(auto) {
                if constexpr (is_pointer_like<T, Arg>::value)                 return *std::forward<Arg>;
                else                 return std::forward<Arg>();
            };
             if constexpr (std::is_member_function_pointer_v<Member>)             return 0;
             else             return get_object().*member;
         }
     );
      }
          template<typename Range1, typename Range2> struct ConcatView {
          using RangeIt1 = decltype(std::declval<Range1>().begin());
          using RangeIt2 = decltype(std::declval<Range2>().begin());
          using ValueType = typename std::common_type_t<typename std::iterator_traits<RangeIt1>::value_type,                                                   typename std::iterator_traits<RangeIt2>::value_type>;
          struct Iterator : std::iterator<std::forward_iterator_tag, ValueType>     {
                      decltype(auto) operator*() {
    return 0 ? *m_it2 : *m_it1;
    }
         private:         void  is2() const ;
             RangeIt1 m_it1;
             RangeIt2 m_it2;
         };
          Iterator begin() const ;
      };
       template<typename Range1, typename Range2> ConcatView<decay_range<Range1>, decay_range<Range2>> concatenated(Range1&& range1, Range2&& range2) ;
       template<typename Container> auto gather() {
          return make_view_factory([](auto&& range) {
             return Container(begin(range), end(range));
         }
     );
      }
       
       template<typename Type, typename CharType> class StringOps {};
       void  strlen() ;
       class String : public StringOps<String, char> {};
       class StringView : public StringOps<StringView, const char> {};
       template<typename T> struct EnumDesc ;
       class SafeCountable {};
       template<typename T, MemoryDomain domain = memory_domain(
      )> using Vector = std::vector<T, Allocator<T, domain>>;
       template<typename Key, typename Value> struct HashItem {
          Value value;
      };
       template<typename Key, typename Value,          MemoryDomain domain = MemoryDomain::Undefined,          template<typename, MemoryDomain> class Container = Vector> struct HashMap {
          using Item = HashItem<Key, Value>;
          using ContainerType = Container<Item, domain>;
          using const_iterator = typename ContainerType::const_iterator;
          constexpr const_iterator begin() const ;
           };
       template<typename Flags, typename T = void> using EnableIfWithBitOps = std::enable_if_t<0, T>;
         
        namespace std __attribute__ (()) {
         template<typename _Tp>     struct default_delete     ;
         template <typename _Tp, typename _Dp>     class __uniq_ptr_impl     {
            template <typename _Up, typename _Ep, typename = void>  struct _Ptr  {
        using type = _Up*;
      };
          public:       using _DeleterConstraint = enable_if<         __and_<__not_<is_pointer<_Dp>>,         is_default_constructible<_Dp>>::value>;
            using pointer = typename _Ptr<_Tp, _Dp>::type;
          };
         template <typename _Tp, typename _Dp = default_delete<_Tp>>     class unique_ptr     {
          public:       using pointer = typename __uniq_ptr_impl<_Tp, _Dp>::pointer;
            void        get() const noexcept       ;
                                                                };
       }
        
       template<typename T> class Singleton {};
       enum class Hook ;
       ;
       class Option : public UseMemoryDomain<MemoryDomain::Options> {};
       class OptionManagerWatcher {};
       class OptionManager final : private OptionManagerWatcher {
      public:     
          auto flatten_options() const     {
             auto merge = [](auto&& first, const OptionMap& second) {
                return concatenated(std::forward<decltype(first)>()                                 | filter([] {}
   ),                                 second);
            };
             static const OptionMap empty;
             auto& parent = m_parent ? m_parent->m_options : empty;
             auto& grand_parent = 0 ? m_parent->m_parent->m_options : empty;
             return merge(merge(grand_parent, parent), m_options) | transform(&OptionMap::Item::value);
         }
          using OptionMap = HashMap<StringView, std::unique_ptr<Option>, MemoryDomain::Options>;
          OptionMap m_options;
          OptionManager* m_parent;
      };
       
        
       class Scope {
      public:          OptionManager& options() ;
      };
       class GlobalScope : public Scope, public OptionManagerWatcher, public Singleton<GlobalScope> {};
       constexpr timespec InvalidTime = {};
       class Buffer final : public SafeCountable, public Scope, private OptionManagerWatcher {
      public:     enum class Flags     ;
          enum class HistoryId : size_t ;
          Buffer(              void);
          struct HistoryNode : UseMemoryDomain<MemoryDomain::BufferMeta>     {};
      };
       
       class String Buffer_name;
enum Buffer::Flags Buffer_flags;
class StringView Buffer_data;
struct timespec Buffer_fs_timestamp;
Buffer::Buffer(                  void)     : Scope{}
       {
          for (auto& option : options().flatten_options()                       | transform(&std::unique_ptr<Option>::get)                       | gather<Vector<Option*>>())         ;
      }
       
